package probalign;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;

/**
 * <p>Title: PROBALIGN</p>
 *
 * <p>Description: </p>
 *
 * @author Satish Chikkagoudar
 * @version Beta 1.0
 */
public class FileOpen extends JDialog {
    JPanel panel1 = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    JFileChooser jFileChooser1 = new JFileChooser();
    public String msafilename = new String();
    Properties env;
    JLabel statusBar;

    public FileOpen(Frame owner, String title, boolean modal,JLabel statusbar) {
        super(owner, title, modal);
        try {
            //System.out.println(System.getProperty("os.name").toLowerCase());

            setDefaultCloseOperation(DISPOSE_ON_CLOSE);
            statusBar=statusbar;
            jbInit();
            pack();

        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    public FileOpen() {
        this(new Frame(), "FileOpen", false,new JLabel());
    }

    private void jbInit() throws Exception {
        panel1.setLayout(borderLayout1);
        jFileChooser1.addActionListener(new
                                        FileOpen_jFileChooser1_actionAdapter(this));
        getContentPane().add(panel1);
        panel1.add(jFileChooser1, java.awt.BorderLayout.CENTER);
    }

    public void jFileChooser1_actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals("ApproveSelection")) {
            msafilename = jFileChooser1.getSelectedFile().toString();
            //System.out.println("Approve!!" + msafilename);
            System.setProperty("MSAFILE",msafilename);
            statusBar.setText("MSAFILE Selected is "+msafilename);
        } else {
            msafilename = "";
            //System.out.println("Reject???");
        }
        //remove the dialog from the screen
        this.dispose();

    }
}


class FileOpen_jFileChooser1_actionAdapter implements ActionListener {
    private FileOpen adaptee;
    FileOpen_jFileChooser1_actionAdapter(FileOpen adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jFileChooser1_actionPerformed(e);
    }
}
