package probalign;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;

/**
 * <p>Title: Application Frame and associated code</p>
 *
 * <p> Version: 1.1 with probalign LM at the backend </p>
 * <p>Description: </p>
 *
 * @author Satish Chikkagoudar
 * @version 1.1
 */

public class Frame1 extends JFrame {
    JPanel contentPane;
    JMenuBar jMenuBar1 = new JMenuBar();
    JMenu jMenuFile = new JMenu();
    JMenuItem jMenuFileExit = new JMenuItem();
    JMenu jMenuHelp = new JMenu();
    JMenuItem jMenuHelpAbout = new JMenuItem();
    JLabel statusBar = new JLabel();
    JMenu jMenu1 = new JMenu();
    JMenuItem jMenuItem1 = new JMenuItem();
    JMenuItem jMenuItem2 = new JMenuItem();
    public String filename = new String();
    TitledBorder titledBorder1 = new TitledBorder("");
    JToolBar jToolBar1 = new JToolBar();
    JScrollPane jScrollPane1;
    DefaultTableModel datamodel = new DefaultTableModel();
    DefaultTableModel namedatamodel = new DefaultTableModel();
    JTable jTable1;
    JComboBox jScoreMatrix = new JComboBox();
    JCheckBox jCheckBox1 = new JCheckBox();
    JTextField jGapOpen = new JTextField();
    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JTextField jGapExt = new JTextField();
    Component component_2 = Box.createHorizontalStrut(8);
    Component component_10 = Box.createHorizontalStrut(8);
    Component component_6 = Box.createHorizontalStrut(8);
    Component component_8 = Box.createHorizontalStrut(8);
    JLabel jLabel4 = new JLabel();
    Component component_4 = Box.createHorizontalStrut(8);
    Component component_1 = Box.createHorizontalStrut(8);
    Component component_5 = Box.createHorizontalStrut(8);
    Component component_3 = Box.createHorizontalStrut(8);
    Component component_7 = Box.createHorizontalStrut(8);
    Component component_9 = Box.createHorizontalStrut(8);
    Component component_13 = Box.createHorizontalStrut(8);
    Component component_14 = Box.createHorizontalStrut(8);
    Component component13 = Box.createHorizontalStrut(8);
    TitledBorder titledBorder2 = new TitledBorder("");
    TitledBorder titledBorder3 = new TitledBorder("");
    Component component_11 = Box.createHorizontalStrut(8);
    String ScoreMatrix = null;
    SwingWorker worker;
    float GapOpen = 0, GapExt = 0;
    int[][] nogaps = null;
    int temperature = 5;

    BorderLayout borderLayout1 = new BorderLayout();
    JTextField jTemp = new JTextField();
    Component component_15 = Box.createHorizontalStrut(10);
    Component component_12 = Box.createHorizontalStrut(8);
    JScrollPane jScrollPane2 = new JScrollPane();
    Component component11a = Box.createHorizontalStrut(8);
    Component component1v = Box.createVerticalStrut(8);
    JLabel jLabel3 = new JLabel();
    JTable jTable2;
    JSplitPane jSplitPane1 = new JSplitPane();
    public Frame1() {
        try {
            this.
                    setDefaultCloseOperation(EXIT_ON_CLOSE);
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    /**
     * Component initialization.
     *
     * @throws java.lang.Exception
     */
    private void jbInit() throws Exception {
        contentPane = (JPanel) getContentPane();
        contentPane.setLayout(borderLayout1);

        this.setCursor(null);
        this.setResizable(true); //false);

        setSize(new Dimension(806, 500));
        setTitle("PROBALIGN");

        statusBar.setAlignmentX((float) 0.5);
        statusBar.setBorder(null);
        statusBar.setDoubleBuffered(true);
        statusBar.setOpaque(false);
        statusBar.setDisplayedMnemonic('0');
        statusBar.setText("probalign");
        jMenuFile.setText("File");
        jMenuItem2.setText("Open");
        jMenuFileExit.setText("Exit");
        jMenuFileExit.addActionListener(new Frame1_jMenuFileExit_ActionAdapter(this));
        jMenuHelp.setText("Help");
        jMenuHelpAbout.setText("About");
        jMenuHelpAbout.addActionListener(new
                                         Frame1_jMenuHelpAbout_ActionAdapter(this));

        jMenuItem2.addActionListener(new
                                     Frame1_jMenuItem2_ActionAdapter(this));

        jMenu1.setText("Align");
        jMenuItem1.setText("Run");
        jMenuItem1.addActionListener(new Frame1_jMenuItem1_ActionAdapter(this));
        jMenuBar1.setForeground(Color.gray);
        jMenuBar1.setAlignmentY((float) 0.5);
        jMenuBar1.setBorder(null);

        jCheckBox1.setMaximumSize(new Dimension(150, 20));
        jCheckBox1.setMinimumSize(new Dimension(150, 20));
        jCheckBox1.setPreferredSize(new Dimension(150, 20));
        jCheckBox1.setText("View Posterior Probs");
        jCheckBox1.addActionListener(new Frame1_jCheckBox1_actionAdapter(this));
        jGapOpen.setBorder(BorderFactory.createLineBorder(Color.black));
        jGapOpen.setMaximumSize(new Dimension(50, 18));
        jGapOpen.setMinimumSize(new Dimension(40, 18));
        jGapOpen.setPreferredSize(new Dimension(40, 18));
        jGapOpen.setInputVerifier(null);
        jGapOpen.setCaretPosition(0);
        jGapOpen.setText("0.0");
        jGapOpen.setHorizontalAlignment(SwingConstants.CENTER);
        jGapOpen.addActionListener(new Frame1_jTextField1_actionAdapter(this));

        jLabel1.setOpaque(true);
        jLabel1.setText("Gap Open");
        jLabel2.setText("Gap Extend");
        jGapExt.setBorder(BorderFactory.createLineBorder(Color.black));
        jGapExt.setMaximumSize(new Dimension(50, 18));
        jGapExt.setMinimumSize(new Dimension(40, 18));
        jGapExt.setPreferredSize(new Dimension(40, 18));
        jGapExt.setCaretPosition(0);
        jGapExt.setText("0.0");
        jGapExt.setHorizontalAlignment(SwingConstants.CENTER);
        jGapExt.addActionListener(new Frame1_jTextField2_actionAdapter(this));
        jScoreMatrix.setBackground(Color.lightGray);
        jScoreMatrix.setBorder(BorderFactory.createLineBorder(Color.black));
        jScoreMatrix.setDoubleBuffered(true);
        jScoreMatrix.setMaximumSize(new Dimension(120, 18));
        jScoreMatrix.setMinimumSize(new Dimension(110, 18));
        jScoreMatrix.setPreferredSize(new Dimension(110, 18));
        jScoreMatrix.setToolTipText("");
        jScoreMatrix.addActionListener(new Frame1_jComboBox1_actionAdapter(this));
        jToolBar1.setBackground(Color.lightGray);
        jToolBar1.setAlignmentX((float) 1);
        jToolBar1.setAlignmentY((float) 1);
        jToolBar1.setBorder(null);
        jToolBar1.setDebugGraphicsOptions(0);
        jToolBar1.setDoubleBuffered(true);
        jToolBar1.setOpaque(false);
        jToolBar1.setToolTipText("");
        jToolBar1.setBorderPainted(false);
        jToolBar1.setMargin(new Insets(0, 0, 0, 0));
        jToolBar1.setPreferredSize(new Dimension(806, 30));
        //java almanac..ref

        jTable1 = new JTable() {
            public boolean isCellEditable(int rowIndex, int vColIndex) {
                return false;
            }
        };
        jTable2 = new JTable() {
            public boolean isCellEditable(int rowIndex, int vColIndex) {
                return false;
            }
        };
        jScrollPane1 = new JScrollPane(jTable1);
        jScrollPane1.setViewportBorder(null);

        jScrollPane1.setAutoscrolls(true);
        jScrollPane1.setBorder(BorderFactory.createLineBorder(Color.black));

        jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.
                                                  HORIZONTAL_SCROLLBAR_ALWAYS); 
						  
        jScrollPane1.setToolTipText("");
        //jLabel4.setMaximumSize(new Dimension(118, 15));
        //jLabel4.setMinimumSize(new Dimension(118, 15));
        jLabel4.setText("Scoring Matrix");
        jTable1.setBackground(Color.white); //lightGray);
        jTable1.setEnabled(true);

        jTable1.setFont(new java.awt.Font("Dialog", Font.PLAIN, 10));
        jTable1.setForeground(Color.darkGray);
        jTable1.setAlignmentX((float) 0.0);
        jTable1.setAlignmentY((float) 0.0);
        jTable1.setBorder(null);
        jTable1.setDoubleBuffered(true);
        jTable1.setIntercellSpacing(new Dimension(0, 0));
        jTable1.setRowMargin(0);
        jTable1.setOpaque(true);
        jTable1.setToolTipText("");
        jTable1.setVerifyInputWhenFocusTarget(false);
        jTable1.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        jTable1.setColumnSelectionAllowed(true);
        jTable1.setGridColor(Color.lightGray);
        jTable1.setSelectionForeground(Color.darkGray);
        jTable1.setShowHorizontalLines(false);
        jTable1.setShowVerticalLines(false);
        jTable1.addKeyListener(new Frame1_jTable1_keyAdapter(this));
        jTable1.addMouseListener(new Frame1_jTable1_mouseAdapter(this));
        //contentPane.setPreferredSize(new Dimension(805, 498));
        jTemp.setMaximumSize(new Dimension(50, 18));
        jTemp.setMinimumSize(new Dimension(40, 18));
        jTemp.setPreferredSize(new Dimension(40, 18));
        jTemp.setText("5");
        jTemp.setBorder(BorderFactory.createLineBorder(Color.black));
        jTemp.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel3.setText("T");
        //jScrollPane2.setPreferredSize(new Dimension(200,498));
        //jScrollPane1.setPreferredSize(new Dimension(705,498));
        //jScrollPane2.setMaximumSize(new Dimension(100,498));
        //jScrollPane1.setMaximumSize(new Dimension(705,498));
        //jScrollPane2.setMinimumSize(new Dimension(200,498));
        //jScrollPane1.setMinimumSize(new Dimension(705,498));

        jScrollPane2.setVerticalScrollBarPolicy(JScrollPane.
                                                VERTICAL_SCROLLBAR_NEVER);
        jScrollPane2.setHorizontalScrollBarPolicy(JScrollPane.
                                                  HORIZONTAL_SCROLLBAR_ALWAYS); 
	//was NEVER before
        jScrollPane2.setBorder(BorderFactory.createLineBorder(Color.black));

        // Listen for value changes in the scroll pane's scrollbars
        AdjustmentListener listener1 = new MyAdjustmentListener1();
        AdjustmentListener listener2 = new MyAdjustmentListener2();
        jScrollPane1.getVerticalScrollBar().addAdjustmentListener(listener1);
        jScrollPane2.getVerticalScrollBar().addAdjustmentListener(listener2);

        jTable2.setFont(new Font("Dialog", Font.PLAIN, 10));
        jTable2.setBorder(null);
        jTable2.setDoubleBuffered(true);
        jTable2.setOpaque(true);
        jTable2.setBackground(Color.lightGray);
        jTable2.setAlignmentX((float) 0.0);
        jTable2.setAlignmentY((float) 0.0);
        jTable2.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        jTable2.setCellSelectionEnabled(false); //true);
        jTable2.setIntercellSpacing(new Dimension(0, 0));
        jTable2.setModel(namedatamodel);
        jTable2.setShowHorizontalLines(false);
        jTable2.setShowVerticalLines(false);
        jTable2.setShowGrid(false);
        jTable1.setRowMargin(0);
        jTable2.setSelectionForeground(Color.darkGray);
        jSplitPane1.setMinimumSize(new Dimension(100, 100));
        jSplitPane1.setContinuousLayout(true);
        jSplitPane1.setLastDividerLocation( -1);
        jSplitPane1.setOneTouchExpandable(true);
        jMenuBar1.add(jMenuFile);
        jMenuBar1.add(jMenu1);
        jMenuBar1.add(jMenuHelp);
        jMenuHelp.add(jMenuHelpAbout);
        setJMenuBar(jMenuBar1);
        jMenu1.add(jMenuItem1);
        jMenuFile.add(jMenuItem2);
        jMenuFile.add(jMenuFileExit);
        jToolBar1.add(component13);
        jToolBar1.add(jLabel1);
        jToolBar1.add(component_1);
        jToolBar1.add(jGapOpen);
        jToolBar1.add(component_2);
        jToolBar1.add(component_3);
        jToolBar1.add(component_4);
        jToolBar1.add(jLabel2);
        jToolBar1.add(component_5);
        jToolBar1.add(jGapExt);
        jToolBar1.add(component_6);
        jToolBar1.add(component_7);
        jToolBar1.add(component_8);
        jToolBar1.add(jLabel3);
        jToolBar1.add(component_9);
        jToolBar1.add(jTemp);
        jToolBar1.add(component_11);
        jToolBar1.add(component_10);
        jToolBar1.add(component11a);
        jToolBar1.add(jLabel4);
        jToolBar1.add(component_12);
        jToolBar1.add(jScoreMatrix);
        jToolBar1.add(component_13);
        jToolBar1.add(component_14);
        jToolBar1.add(component_15);
        contentPane.add(statusBar, java.awt.BorderLayout.SOUTH);
        //jScrollPane1.getViewport().add(jTable1);
        jSplitPane1.add(jScrollPane1, JSplitPane.RIGHT);
        jScrollPane1.getViewport().add(jTable1);
        jSplitPane1.add(jScrollPane2, JSplitPane.LEFT);
        jSplitPane1.setDividerLocation(100);
        jScrollPane2.getViewport().add(jTable2);
        contentPane.add(jSplitPane1, java.awt.BorderLayout.CENTER);
        contentPane.add(jToolBar1, java.awt.BorderLayout.NORTH); //jScrollPane2.getViewport().add(jTable2);
        jScoreMatrix.insertItemAt("gonnet_160", 0);
        jScoreMatrix.insertItemAt("nuc_simple", 1);
        jScoreMatrix.setSelectedIndex(0);
        jTable1.setTableHeader(null);
        jTable2.setTableHeader(null);
    }


    /**
     * File | Exit action performed.
     *
     * @param actionEvent ActionEvent
     */
    void jMenuFileExit_actionPerformed(ActionEvent actionEvent) {
        System.exit(0);
    }

    /**
     * Help | About action performed.
     *
     * @param actionEvent ActionEvent
     */
    void jMenuHelpAbout_actionPerformed(ActionEvent actionEvent) {
        Frame1_AboutBox dlg = new Frame1_AboutBox(this);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x,
                        (frmSize.height - dlgSize.height) / 2 + loc.y);
        dlg.setModal(true);
        dlg.pack();
        dlg.setVisible(true);
    }


    void jMenuItem2_actionPerformed(ActionEvent actionEvent) {
        FileOpen dlg = new FileOpen(this, "Open", true, statusBar);
        filename = dlg.msafilename;
        //System.out.println("filename:" + filename);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x,
                        (frmSize.height - dlgSize.height) / 2 + loc.y);
        dlg.setModal(true);

        dlg.pack();
        dlg.setVisible(true);
        jTable1.setModel(new DefaultTableModel());
        jTable2.setModel(new DefaultTableModel());
        filename = System.getProperty("MSAFILE");

        SwingWorker worker = new SwingWorker() {


            public Object construct() {
                jMenuItem1.setEnabled(false);
                DoLoadFile();
                return null;
            }

            public void finished() {
                jMenuItem1.setEnabled(true);
                jTable1.repaint();
                jTable2.repaint();
            }

        };

        worker.start();

    }


    void DoLoadFile() {
        String line = null;
        int maxlength = 0;
//cout stream handled here
        int j = -1;
        Object[][] temps = null;
        Object[][] names = null;
        nogaps = null;

        String namestring = null, sequencestring = null;
        int ii = 0, templength = 0;
        int alignmentflag = 0, lineno = 0;
        int numColumns = 0, numSeqs = 0, nongapcount = 0;
        int maxnamelength = 0;
        String[] splitter = new String[2];

        try {

            BufferedReader grep = new BufferedReader(new FileReader(filename));

            BufferedReader infile = new BufferedReader(new FileReader(filename));

            while ((line = grep.readLine()) != null) {
                if (line.lastIndexOf(">") != -1) {
                    numSeqs++;
                }

            }
            names = new Object[numSeqs][1];
            temps = new Object[numSeqs][1];

            while ((line = infile.readLine()) != null) {
               
	        //System.out.println(line);
               
	        if (templength > maxlength) {
                    maxlength = templength;
                }

                if (line.lastIndexOf(">") != -1) {

                    j++;
                    if (j > 0) {
                        temps[j - 1][0] = sequencestring;
                    }
                    nongapcount = 0;
                    ii = 0;
                    names[j][0] = line.replace('>', ' ');
                    if (maxnamelength < line.length()) {
                        maxnamelength = line.length();
                    }
                    sequencestring = new String();
                    temps[j][0] = "";
                    templength = 0;
                    continue;

                }

                

                templength += line.length();
                sequencestring += line;

            }
            
	    temps[j][0]=sequencestring;    

            datamodel.setDataVector(temps, new Object[1]);
            namedatamodel.setDataVector(names, new Object[1]);

            jTable1.setModel(datamodel);

            jTable2.setModel(namedatamodel);
            //Get the column model.

            TableColumnModel namecolModel = jTable2.getColumnModel();
            namecolModel.setColumnMargin(0);
            namecolModel.getColumn(0).setMinWidth(maxnamelength *
                                                  jTable2.getFontMetrics(jTable2.getFont()).
                                                  charWidth('W'));
            namecolModel.getColumn(0).sizeWidthToFit();

            TableColumnModel colModel = jTable1.getColumnModel();
            colModel.setColumnMargin(0);

            //Get the column at index pColumn, and set its preferred width.


            TableColumn tc1 = namecolModel.getColumn(0);

            tc1.setCellRenderer(new MyNameCellRenderer(numColumns, numSeqs));

            TableColumn tc2 = colModel.getColumn(0);
            tc2.setCellRenderer(new MyNameCellRenderer(numColumns, numSeqs));

            colModel.getColumn(0).setMinWidth(maxlength *
                                              jTable1.
                                              getFontMetrics(jTable1.getFont()).
                                              charWidth('W'));

            statusBar.setText("Loaded " + filename);

            infile.close();
            grep.close();
        } catch (IOException e) {
            System.out.println(e.getStackTrace());
        }

    }


    void jMenuItem1_actionPerformed(ActionEvent actionEvent) {
        //action for align

        SwingWorker worker = new SwingWorker() {


            public Object construct() {
                jMenuItem1.setEnabled(false);
                DoProbalignRuns();

                return null;
            }

            public void finished() {
                jMenuItem1.setEnabled(true);
                Runtime rt = Runtime.getRuntime();
                rt.gc();
                jTable2.revalidate();
                jTable1.revalidate();
                jTable1.repaint();
                jTable2.repaint();
            }

        };

        worker.start();

    }


    void DoProbalignRuns() { //align

        Properties env = new Properties();
        filename = System.getProperty("MSAFILE");

        //enable for windows
        //String command = new String("c:/probalign/PROBALIGN ");
        //command = command + "\"" + filename + "\"";

        //method 2..to use comment out earlier assignment and assign
        //this to it instead
        //System.getenv("PROBALIGN_HOME");

        //unix code
        String command = new String("./probalign/bin/probalign ");
        command = command + filename;

        GapOpen = Float.parseFloat(jGapOpen.getText());
        GapExt = Float.parseFloat(jGapExt.getText());
        temperature = Integer.parseInt(jTemp.getText());

        command = command + " -T " + temperature;

        if (GapOpen != 0.0) {
            command = command + " -go " + GapOpen;
        }

        if (GapExt != 0.0) {
            command = command + " -ge " + GapExt;
        }

        if (ScoreMatrix != null) {
            command = command + " -score_matrix " + ScoreMatrix;
        }

        //System.out.println("command was: " + command);
        statusBar.setText(" Processing  " + filename);
        System.setSecurityManager(null);
        try {
            Runtime rt = Runtime.getRuntime();
            rt.gc();
            Process proc = rt.exec(command + " -columnscore");

            InputStream instream = proc.getInputStream();
            InputStreamReader coutisr = new InputStreamReader(instream);
            BufferedReader coutbr = new BufferedReader(coutisr);

            InputStream stderr = proc.getErrorStream();
            InputStreamReader errisr = new InputStreamReader(stderr);
            BufferedReader errbr = new BufferedReader(errisr);

            String line = null;
            int maxlength = 0;
            //cout stream handled here
            int j = -1;
            Object[][] temps = null;
            Object[][] names = null;
            nogaps = null;
            float[] probs = null;
            int ii = 0, templength = 0;
            int alignmentflag = 0, lineno = 0, maxnamelength = 0,
                    namelength = 0;
            int numColumns = 0, numSeqs = 0, nongapcount = 0;
            String[] splitter = new String[2];

            while ((line = coutbr.readLine()) != null) {
                //System.out.println(line);

                if (maxlength < templength) {
                    maxlength = templength;
                }

                if (line.lastIndexOf(">") != -1) {
                    j++;
                    nongapcount = 0;
                    ii = 0;
                    names[j][0] = line.replace('>', ' ');

                    templength = 0;
                    //namelength=line.length();
                    //if(namelength > maxnamelength)
                    //   maxnamelength = namelength;
                    alignmentflag = 1;
                    continue;

                }
                if (lineno > 2 && lineno < (numColumns + 2)) {
                    splitter = line.split(" ");
                    probs[Integer.parseInt(splitter[0])] = Float.parseFloat(
                            splitter[1]);
                }
                if (lineno == 0) {
                    numSeqs = Integer.parseInt(line);
                    //System.out.println(numSeqs);

                }

                if (lineno == 1) {

                    numColumns = Integer.parseInt(line);
                    //
                    temps = new Object[numSeqs][numColumns]; //+ 1]; //1 extra to fit name
                    nogaps = new int[numSeqs][numColumns]; // + 1];
                    probs = new float[numColumns]; // + 1];
                    names = new Object[numSeqs][1];
                }

                lineno++;
                if (alignmentflag == 0) {
                    continue;
                }

                char[] temp = line.toCharArray();
                templength += temp.length;

                for (int i = 0; i < temp.length; i++) {
                    if (temp[i] != '\n' || temp[i] != '\t' || temp[i] != ' ') {
                        temps[j][ii] = String.valueOf(temp[i]);
                        if (temp[i] != '-') {
                            nogaps[j][ii] = ++nongapcount;
                        } else {
                            nogaps[j][ii] = nongapcount;
                        }
                        ii++;
                    }

                }

            }

            datamodel.setDataVector(temps, new Object[maxlength]);
            namedatamodel.setDataVector(names, new Object[1]);

            jTable1.setModel(datamodel);

            jTable2.setModel(namedatamodel);
            //Get the column model.

            TableColumnModel namecolModel = jTable2.getColumnModel();
            namecolModel.setColumnMargin(0);

            TableColumnModel colModel = jTable1.getColumnModel();
            colModel.setColumnMargin(0);

            //Get the column at index pColumn, and set its preferred width.


            TableColumn tc1 = namecolModel.getColumn(0);
            namecolModel.getColumn(0).setMaxWidth(1000);
            namecolModel.getColumn(0).setMinWidth(1000);
            //save processing time
            //maxnamelength*(jTable1.getFontMetrics(jTable1.getFont()).charWidth('W')));

            tc1.setCellRenderer(new MyNameCellRenderer(numColumns, numSeqs));

            //System.out.println(jTable1.getFont().getFontName());


            char valuelookingat;
            int maxwidth = 0, currwidth;
            for (int i = 0; i < maxlength; i++) {
                maxwidth = 0;
                colModel.getColumn(i).setMinWidth(0);

                for (j = 0; j < numSeqs; j++) {
                    valuelookingat = (temps[j][i].toString()).charAt(0);
                    currwidth = jTable1.getFontMetrics(jTable1.getFont()).
                                charWidth(valuelookingat);
                    if (currwidth > maxwidth) {
                        maxwidth = currwidth;
                    }
                }
                colModel.getColumn(i).setMaxWidth(maxwidth); //+1);

                colModel.getColumn(i).sizeWidthToFit();

                colModel.getColumn(i).setCellRenderer(new MyTableCellRenderer(
                        numColumns, numSeqs, statusBar, probs));
            }

            statusBar.setText(" Processing  " + filename);
            //cerr handled here
            line = null;

            while ((line = errbr.readLine()) != null) {
                //System.out.println(line);

            }

            int exitVal = proc.waitFor();
            //System.out.println("Process exitValue: " + exitVal);
            statusBar.setText(" Processed  " + filename);

            errbr.close();
            coutbr.close();
            coutisr.close();
            errisr.close();
            instream.close();
            stderr.close();
        } catch (Exception t) {
            t.printStackTrace();
        }

    }

    public void jTextField2_actionPerformed(ActionEvent e) {
        GapExt = Float.parseFloat(jGapExt.getText());

    }

    public void jCheckBox1_actionPerformed(ActionEvent e) {
        //System.out.println(jCheckBox1.getModel().isSelected());
    }

    public void jComboBox1_actionPerformed(ActionEvent e) {
        //System.out.println(jScoreMatrix.getSelectedItem());
        ScoreMatrix = jScoreMatrix.getSelectedItem().toString();

        if (ScoreMatrix.equals("gonnet_160")) {
            jGapOpen.setText("22.0");
            jGapExt.setText("1.0");
            jTemp.setText("5");
        } else {
            jGapOpen.setText("4.0");
            jGapExt.setText("0.25");
            jTemp.setText("1");
        }
    }


    public void jTextField1_actionPerformed(ActionEvent e) {
        //System.out.println(jGapOpen.getText());
        GapOpen = Float.parseFloat(jGapOpen.getText());
    }

    public void jTable1_mouseClicked(MouseEvent e) {

        int rowIndex, vColIndex;
        rowIndex = jTable1.getSelectedRow();
        vColIndex = jTable1.getSelectedColumn();
        statusBar.setText("Sequence:" + (rowIndex + 1) + " Position:" +
                          (vColIndex + 1) + "|" + nogaps[rowIndex][vColIndex] +
                          "   [" + jTable2.getValueAt(rowIndex, 0) + " ]");

    }


    public void jTable1_keyReleased(KeyEvent e) {

        int rowIndex, vColIndex;
        rowIndex = jTable1.getSelectedRow();
        vColIndex = jTable1.getSelectedColumn();

        //if(e.getKeyCode()==e.VK_UP||e.getKeyCode()==e.VK_DOWN||e.getKeyCode()==e.VK_RIGHT || e.getKeyCode()==e.VK_LEFT)
        statusBar.setText("Sequence:" + (rowIndex + 1) + " Position:" +
                          (vColIndex + 1) + "|" + nogaps[rowIndex][vColIndex] +
                          "   [" + jTable2.getValueAt(rowIndex, 0) + " ]");

    }


    class Frame1_jMenuItem2_ActionAdapter implements ActionListener {
        Frame1 adaptee;

        Frame1_jMenuItem2_ActionAdapter(Frame1 adaptee) {
            this.adaptee = adaptee;
        }

        public void actionPerformed(ActionEvent actionEvent) {
            adaptee.jMenuItem2_actionPerformed(actionEvent);
        }
    }


    class Frame1_jMenuItem1_ActionAdapter implements ActionListener {
        Frame1 adaptee;

        Frame1_jMenuItem1_ActionAdapter(Frame1 adaptee) {
            this.adaptee = adaptee;
        }

        public void actionPerformed(ActionEvent actionEvent) {
            adaptee.jMenuItem1_actionPerformed(actionEvent);
        }
    }


    class Frame1_jMenuFileExit_ActionAdapter implements ActionListener {
        Frame1 adaptee;

        Frame1_jMenuFileExit_ActionAdapter(Frame1 adaptee) {
            this.adaptee = adaptee;
        }

        public void actionPerformed(ActionEvent actionEvent) {
            adaptee.jMenuFileExit_actionPerformed(actionEvent);
        }
    }


    class Frame1_jMenuHelpAbout_ActionAdapter implements ActionListener {
        Frame1 adaptee;

        Frame1_jMenuHelpAbout_ActionAdapter(Frame1 adaptee) {
            this.adaptee = adaptee;
        }


        public void actionPerformed(ActionEvent actionEvent) {
            adaptee.jMenuHelpAbout_actionPerformed(actionEvent);
        }

    }


    class Frame1_jTable1_mouseAdapter extends MouseAdapter {
        private Frame1 adaptee;
        Frame1_jTable1_mouseAdapter(Frame1 adaptee) {
            this.adaptee = adaptee;
        }

        public void mouseClicked(MouseEvent e) {
            adaptee.jTable1_mouseClicked(e);
        }
    }


    class Frame1_jTable1_keyAdapter extends KeyAdapter {
        private Frame1 adaptee;
        Frame1_jTable1_keyAdapter(Frame1 adaptee) {
            this.adaptee = adaptee;
        }

        public void keyReleased(KeyEvent e) {
            adaptee.jTable1_keyReleased(e);
        }
    }


    class Frame1_jTextField1_actionAdapter implements ActionListener {
        private Frame1 adaptee;
        Frame1_jTextField1_actionAdapter(Frame1 adaptee) {
            this.adaptee = adaptee;
        }

        public void actionPerformed(ActionEvent e) {
            adaptee.jTextField1_actionPerformed(e);
        }
    }


    class Frame1_jComboBox1_actionAdapter implements ActionListener {
        private Frame1 adaptee;
        Frame1_jComboBox1_actionAdapter(Frame1 adaptee) {
            this.adaptee = adaptee;
        }

        public void actionPerformed(ActionEvent e) {
            adaptee.jComboBox1_actionPerformed(e);
        }
    }


    class Frame1_jCheckBox1_actionAdapter implements ActionListener {
        private Frame1 adaptee;
        Frame1_jCheckBox1_actionAdapter(Frame1 adaptee) {
            this.adaptee = adaptee;
        }

        public void actionPerformed(ActionEvent e) {
            adaptee.jCheckBox1_actionPerformed(e);
        }
    }


    class Frame1_jTextField2_actionAdapter implements ActionListener {
        private Frame1 adaptee;
        Frame1_jTextField2_actionAdapter(Frame1 adaptee) {
            this.adaptee = adaptee;
        }

        public void actionPerformed(ActionEvent e) {
            adaptee.jTextField2_actionPerformed(e);
        }

    }


//java almanac code
//http://javaalmanac.com/egs/javax.swing.table/CustRend.html
// This renderer extends a component. It is used each time a
// cell must be displayed.
    class MyTableCellRenderer extends JLabel implements TableCellRenderer {
        // This method is called each time a cell in a column
        // using this renderer needs to be rendered.
        int numColumns, numSeqs;
        JLabel statusBar;
        float[] probs;

        MyTableCellRenderer(int numcolumns, int numseqs, JLabel jstatusBar,
                            float[] columprob) {

            numColumns = numcolumns;
            numSeqs = numseqs;
            statusBar = jstatusBar;
            probs = columprob;
        }

        public Component getTableCellRendererComponent(JTable table,
                Object value,
                boolean isSelected, boolean hasFocus, int rowIndex,
                int vColIndex) {
            // 'value' is value contained in the cell located at
            // (rowIndex, vColIndex)
            this.setFont(new java.awt.Font("Dialog", Font.PLAIN, 10));

            this.setHorizontalAlignment(SwingConstants.CENTER);

            if (isSelected) {
                // cell (and perhaps other cells) are selected
                if (rowIndex < numSeqs) {
                    setBackground(Color.BLACK);
                    setForeground(Color.WHITE);
                } else {
                    setBackground(getBackground());

                    setForeground(getForeground());
                }
                //System.out.println("selected");
            }

            if (hasFocus) {
                // this cell is the anchor and the table has the focus
                setBackground(getBackground());
                setForeground(getForeground());

                // System.out.println("focussed:" + rowIndex + "   " + vColIndex);

            }

            // Configure the component with the specified value
            setOpaque(true);

            float tempprobs = probs[vColIndex];

            if (rowIndex < numSeqs) {
                int colorcategory = 0;
                if (tempprobs < 0.1) {
                    colorcategory = 1;
                } else if (tempprobs < 0.2) {
                    colorcategory = 2;
                } else if (tempprobs < 0.3) {
                    colorcategory = 3;
                } else if (tempprobs < 0.4) {
                    colorcategory = 4;
                } else if (tempprobs < 0.5) {
                    colorcategory = 5;
                } else if (tempprobs < 0.6) {
                    colorcategory = 6;
                } else if (tempprobs < 0.7) {
                    colorcategory = 7;
                } else if (tempprobs < 0.8) {
                    colorcategory = 8;
                } else if (tempprobs < 0.9) {
                    colorcategory = 9;
                } else {
                    colorcategory = 10;
                }
                int redvalue = (int) ((255.0 / 10) * colorcategory);

                if (isSelected) {
                    setForeground(getForeground());

                    setText(value.toString());

                    setBackground(getBackground());
                    setToolTipText(Float.toString(probs[vColIndex]));
                } else {
                    setForeground(Color.black);
                    setText(value.toString());

                    setBackground(new Color((float) 1.0, (float) 0.0,
                                            (float) 0.0, probs[vColIndex]));
                    //(colorcategory/10.0)));//redvalue, 0, 0));
                    setToolTipText(Float.toString(probs[vColIndex]));

                }

            } else {
                setBackground(Color.lightGray);
                setForeground(Color.lightGray);

            }

// Since the renderer is a component, return itself
            return this;
        }

        // The following methods override the defaults for performance reasons
        //  public void validate() {}
        //  public void revalidate() {}
        //  protected void firePropertyChange(String propertyName, Object oldValue, Object newValue) {}
        //  public void firePropertyChange(String propertyName, boolean oldValue, boolean newValue) {}
    }


//renderer for table2
    class MyNameCellRenderer extends JLabel implements TableCellRenderer {
        // This method is called each time a cell in a column
        // using this renderer needs to be rendered.
        int numColumns, numSeqs;


        MyNameCellRenderer(int numcolumns, int numseqs) {

            numColumns = numcolumns;
            numSeqs = numseqs;
        }

        public Component getTableCellRendererComponent(JTable table,
                Object value,
                boolean isSelected, boolean hasFocus, int rowIndex,
                int vColIndex) {
            // 'value' is value contained in the cell located at
            // (rowIndex, vColIndex)
            this.setFont(new java.awt.Font("Dialog", Font.PLAIN, 10));
            this.setHorizontalAlignment(SwingConstants.LEFT);

            if (isSelected) {
                // cell (and perhaps other cells) are selected
                setBackground(getBackground());
                setForeground(getForeground());
            }

            if (hasFocus) {
                // this cell is the anchor and the table has the focus
                setBackground(getBackground());
                setForeground(getForeground());

                // System.out.println("focussed:" + rowIndex + "   " + vColIndex);

            }

            // Configure the component with the specified value
            setOpaque(true);

            if (rowIndex < numSeqs) {
                setBackground(getBackground());
                setForeground(getForeground());
                setText(value.toString());
            } else {
                setBackground(getBackground());
                setForeground(getForeground());
            }

// Since the renderer is a component, return itself
            return this;
        }

        // The following methods override the defaults for performance reasons
        //  public void validate() {}
        //  public void revalidate() {}
        //  protected void firePropertyChange(String propertyName, Object oldValue, Object newValue) {}
        //  public void firePropertyChange(String propertyName, boolean oldValue, boolean newValue) {}
    }


    class MyAdjustmentListener1 implements AdjustmentListener {
        // This method is called whenever the value of a scrollbar is changed,
        // either by the user or programmatically.
        public void adjustmentValueChanged(AdjustmentEvent evt) {
            Adjustable source = evt.getAdjustable();

            // getValueIsAdjusting() returns true if the user is currently
            // dragging the scrollbar's knob and has not picked a final value
            if (evt.getValueIsAdjusting()) {
                jScrollPane2.getVerticalScrollBar().setValue(evt.getValue());
                // The user is dragging the knob
                return;
            }

            // Determine the type of event
            int type = evt.getAdjustmentType();
            switch (type) {
            case AdjustmentEvent.UNIT_INCREMENT:

                // Scrollbar was increased by one unit
                break;
            case AdjustmentEvent.UNIT_DECREMENT:

                // Scrollbar was decreased by one unit
                break;
            case AdjustmentEvent.BLOCK_INCREMENT:

                // Scrollbar was increased by one block
                break;
            case AdjustmentEvent.BLOCK_DECREMENT:

                // Scrollbar was decreased by one block
                break;
            case AdjustmentEvent.TRACK:

                // The knob on the scrollbar was dragged
                break;
            }
            // Get current value

            jScrollPane2.getVerticalScrollBar().setValue(evt.getValue());

        }
    }


    class MyAdjustmentListener2 implements AdjustmentListener {


        // This method is called whenever the value of a scrollbar is changed,
        // either by the user or programmatically.
        public void adjustmentValueChanged(AdjustmentEvent evt) {
            Adjustable source = evt.getAdjustable();

            // getValueIsAdjusting() returns true if the user is currently
            // dragging the scrollbar's knob and has not picked a final value
            if (evt.getValueIsAdjusting()) {
                // The user is dragging the knob
                jScrollPane1.getVerticalScrollBar().setValue(evt.getValue());
                return;
            }

            // Determine the type of event
            int type = evt.getAdjustmentType();
            switch (type) {
            case AdjustmentEvent.UNIT_INCREMENT:

                // Scrollbar was increased by one unit
                break;
            case AdjustmentEvent.UNIT_DECREMENT:

                // Scrollbar was decreased by one unit
                break;
            case AdjustmentEvent.BLOCK_INCREMENT:

                // Scrollbar was increased by one block
                break;
            case AdjustmentEvent.BLOCK_DECREMENT:

                // Scrollbar was decreased by one block
                break;
            case AdjustmentEvent.TRACK:

                // The knob on the scrollbar was dragged
                break;
            }

            // Get current value
            jScrollPane1.getVerticalScrollBar().setValue(evt.getValue());
        }
    }
}
