package probalign;

import java.awt.*;

import javax.swing.*;

/**
 * <p>Title:PROBALIGN </p>
 *
 * <p>Description:  Java GUI/Frontend </p>
 *
 * @author Satish Chikkagoudar
 * @version Beta 1.0
 */
public class gui {
    boolean packFrame = false;

    /**
     * Construct and show the application.
     */
    public gui() {
        Frame1 frame = new Frame1();


        // Validate frames that have preset sizes
        // Pack frames that have useful preferred size info, e.g. from their layout
        if (packFrame) {
            frame.pack();
        } else {
            frame.validate();
        }

        // Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2,
                          (screenSize.height - frameSize.height) / 2);

        frame.setVisible(true);
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * Application entry point.
     *
     * @param args String[]
     *
     */
    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                try {
                    UIManager.setLookAndFeel(UIManager.
                                             //getCrossPlatformLookAndFeelClassName());
                                             getSystemLookAndFeelClassName());
		     Toolkit.getDefaultToolkit().setDynamicLayout(true);
                } catch (Exception exception) {
                    exception.printStackTrace();
                }

                new gui();
            }
        });
    }

    private void jbInit() throws Exception {
    }
}
